"use strict";

require("core-js/modules/es.array.concat");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transform = transform;

var _readAsObject = require("./dependencies-lookup/readAsObject");

function transform(inputSource) {
  return (0, _readAsObject.readStory)(this, inputSource).then(function (sourceObject) {
    // if source-loader had trouble parsing the story exports, return the original story
    // example is
    // const myStory = () => xxx
    // export { myStory }
    if (!sourceObject.source || sourceObject.source.length === 0) {
      return inputSource;
    }

    var source = sourceObject.source,
        sourceJson = sourceObject.sourceJson,
        addsMap = sourceObject.addsMap;
    var preamble = "\n      /* eslint-disable */\n      // @ts-nocheck\n      // @ts-ignore\n      var __STORY__ = ".concat(sourceJson, ";\n      // @ts-ignore\n      var __LOCATIONS_MAP__ = ").concat(JSON.stringify(addsMap), ";\n    ");
    return "".concat(preamble, "\n").concat(source);
  });
}