"use strict";

require("core-js/modules/es.function.bind");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.promise");

require("core-js/modules/es.regexp.exec");

require("core-js/modules/es.string.replace");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.readStory = readStory;

var _loaderUtils = require("loader-utils");

var _injectDecorator = _interopRequireDefault(require("../abstract-syntax-tree/inject-decorator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function readAsObject(classLoader, inputSource, mainFile) {
  var options = (0, _loaderUtils.getOptions)(classLoader) || {};
  var result = (0, _injectDecorator["default"])(inputSource, classLoader.resourcePath, Object.assign(Object.assign({}, options), {}, {
    parser: options.parser || classLoader.extension
  }), classLoader.emitWarning.bind(classLoader));
  var sourceJson = JSON.stringify(result.storySource || inputSource).replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029");
  var addsMap = result.addsMap || {};
  var source = mainFile ? result.source : inputSource;
  return new Promise(function (resolve) {
    return resolve({
      source: source,
      sourceJson: sourceJson,
      addsMap: addsMap
    });
  });
}

function readStory(classLoader, inputSource) {
  return readAsObject(classLoader, inputSource, true);
}